package com.ktg.iscs.service.impl;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ktg.common.core.text.Convert;
import com.ktg.common.utils.DateUtils;
import com.ktg.iscs.domain.IsLocksetType;
import com.ktg.iscs.domain.vo.locksetType.IsLocksetTypeVO;
import com.ktg.iscs.mapper.IsLocksetTypeMapper;
import com.ktg.iscs.service.IIsLocksetTypeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 锁具类型Service业务层处理
 *
 * @author cgj
 * @date 2024-11-19
 */
@Service
public class IsLocksetTypeServiceImpl extends ServiceImpl<IsLocksetTypeMapper, IsLocksetType> implements IIsLocksetTypeService
{
    @Autowired
    private IsLocksetTypeMapper isLocksetTypeMapper;

    /**
     * 查询锁具类型
     *
     * @param locksetTypeId 锁具类型主键
     * @return 锁具类型
     */
    @Override
    public IsLocksetType selectIsLocksetTypeByLocksetTypeId(Long locksetTypeId)
    {
        return isLocksetTypeMapper.selectIsLocksetTypeByLocksetTypeId(locksetTypeId);
    }

    /**
     * 查询锁具类型列表
     *
     * @param isLocksetType 锁具类型
     * @return 锁具类型
     */
    @Override
    public List<IsLocksetType> selectIsLocksetTypeList(IsLocksetType isLocksetType)
    {
        return isLocksetTypeMapper.selectIsLocksetTypeList(isLocksetType);
    }

    /**
     * 新增锁具类型
     *
     * @param isLocksetType 锁具类型
     * @return 结果
     */
    @Override
    public int insertIsLocksetType(IsLocksetType isLocksetType)
    {
        // 1.检查锁具类型名称是否重复
        List<IsLocksetType> list = list(Wrappers.<IsLocksetType>lambdaQuery()
                .eq(IsLocksetType::getLocksetTypeName, isLocksetType.getLocksetTypeName()));
        Assert.isFalse(!list.isEmpty(), "该锁具类型名称已被使用!");
        // 2.检查锁具类型编码是否重复
        List<IsLocksetType> isLocksetTypes = list(Wrappers.<IsLocksetType>lambdaQuery()
                .eq(IsLocksetType::getLocksetTypeCode, isLocksetType.getLocksetTypeCode()));
        Assert.isFalse(!isLocksetTypes.isEmpty(), "该锁具类型编码已被使用!");
        isLocksetType.setCreateTime(DateUtils.getNowDate());
        return isLocksetTypeMapper.insertIsLocksetType(isLocksetType);
    }

    /**
     * 修改锁具类型
     *
     * @param isLocksetType 锁具类型
     * @return 结果
     */
    @Override
    public int updateIsLocksetType(IsLocksetType isLocksetType)
    {
        // 1.检查锁具类型名称是否重复
        List<IsLocksetType> list = list(Wrappers.<IsLocksetType>lambdaQuery()
                .eq(IsLocksetType::getLocksetTypeName, isLocksetType.getLocksetTypeName())
                .ne(IsLocksetType::getLocksetTypeId, isLocksetType.getLocksetTypeId()));
        Assert.isFalse(!list.isEmpty(), "该锁具类型名称已被使用!");
        // 2.检查锁具类型编码是否重复
        List<IsLocksetType> isLocksetTypes = list(Wrappers.<IsLocksetType>lambdaQuery()
                .eq(IsLocksetType::getLocksetTypeCode, isLocksetType.getLocksetTypeCode())
                .ne(IsLocksetType::getLocksetTypeId, isLocksetType.getLocksetTypeId()));
        Assert.isFalse(!isLocksetTypes.isEmpty(), "该锁具类型编码已被使用!");
        isLocksetType.setUpdateTime(DateUtils.getNowDate());
        return isLocksetTypeMapper.updateIsLocksetType(isLocksetType);
    }

    /**
     * 批量删除锁具类型
     *
     * @param locksetTypeIds 需要删除的锁具类型主键
     * @return 结果
     */
    @Override
    public int deleteIsLocksetTypeByLocksetTypeIds(String locksetTypeIds)
    {
        Assert.notBlank(locksetTypeIds, "请选择需要删除的数据!");
        Long[] longIds = Convert.toLongArray(locksetTypeIds);
        // 检查有没有子集
        List<IsLocksetType> list = list(Wrappers.<IsLocksetType>lambdaQuery()
                .in(IsLocksetType::getParentTypeId, longIds));
        Assert.isTrue(list.isEmpty(), "请先移除子集");
        return isLocksetTypeMapper.deleteIsLocksetTypeByLocksetTypeIds(longIds);
    }

    /**
     * 删除锁具类型信息
     *
     * @param locksetTypeId 锁具类型主键
     * @return 结果
     */
    @Override
    public int deleteIsLocksetTypeByLocksetTypeId(Long locksetTypeId)
    {
        return isLocksetTypeMapper.deleteIsLocksetTypeByLocksetTypeId(locksetTypeId);
    }

    @Override
    public Page<IsLocksetTypeVO> getIsLocksetTypePage(Page<IsLocksetType> page, IsLocksetType isLocksetType) {
        return isLocksetTypeMapper.getIsLocksetTypePage(page, isLocksetType);
    }
}
